/*
*   biff.c
*       Yet Another Osuwari Multi for X11
*       (Biff Module)
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<pwd.h>			/* for passwd */
#include	<sys/stat.h>	/* for stat, needs types.h */

#include	<X11/Xlib.h>
#include	<X11/Xutil.h>

#include	<X11/bitmaps/flagup>
		/*
		| ᡼뤬äѤΤȤΥӥåȥޥåס
		|	char*	flagup_bits;
		|	int		flagup_width;
		|	int		flagup_height;
		| ޤޤƤ롣
		| ᡼γ򺹤ؤȤˤϡΥӥåȥޥåפѹ٤
		*/

/******** ᡼롦סǥ쥯ȥ ********
* 
* ᡼롦סǥ쥯ȥϥޥĶˤäưۤʤ롣
*  "/usr/spool/mail"  "/usr/mail" ˤΤ
* ⤷äƤˤϡʬδĶ˹碌
* MAILBOX_DIRECTRY ꤹɬפ롣
*/

#ifndef MAILBOX_DIRECTORY

#ifdef	SYSV
#define	MAILBOX_DIRECTORY	"/usr/mail"
#endif

#ifdef	SVR4
#define	MAILBOX_DIRECTORY	"/var/mail"
#endif

#ifdef	CSRG_BASED
#include	<paths.h>
#ifdef	_PATH_MAILDIR
#define	MAILBOX_DIRECTOR	_PATH_MAILDIR
#endif
#endif

#endif

#ifndef MAILBOX_DIRECTORY
#define MAILBOX_DIRECTORY	"/usr/spool/mail"	/* <- ǥեȤ */
#endif

/******** External Value ********/

/* in xosmulti.c */

extern Display	*Disp;
extern Window	RootWin;

extern unsigned long	FgPixel, BgPixel;

extern XFontStruct	*theFont;
extern int		FontHeight;
extern Bool		isKanji;

/* in message.c */

extern char	*BiffMsg;

/******** Global Value ********/

static Window	BiffWin;
static int	BiffWidth, BiffHeight;
static Bool isBiffMapped = False;

static char	*MBoxFileName = NULL;

/******** External Function ********/

/* in xosmulti.c */
extern void		TalkShape( );
extern XChar2b	*Str2bCpy( );

/******** Functions Prototype ********/

void	CreateBiff();
static char	*GetMailFile();
void	MoveBiff();
void	UpBiff();
void	DownBiff();
void	CheckBiff();
void	DestroyBiff();
static Pixmap	CreateBiffPixmap();

/******** CreateBiff ********
* Biffɥ
*/
void	CreateBiff()
{
	XSetWindowAttributes	xswa;
	int	biff_width = 120, biff_height = 64;

	BiffWin = XCreateSimpleWindow( Disp, RootWin,
				0, 0, biff_width, biff_height, 1,
				FgPixel, BgPixel );

	xswa.override_redirect = True;

	xswa.background_pixmap = CreateBiffPixmap( &biff_width, &biff_height );
			
	XChangeWindowAttributes( Disp, BiffWin,
				CWOverrideRedirect | CWBackPixmap, &xswa );
	
	/* դڤ */
	TalkShape( Disp, BiffWin, biff_width, biff_height, 1 );

	/* ⤵ݻ */
	BiffWidth  = biff_width;
	BiffHeight = biff_height;

	/* ֤Ǥɽ */
	DownBiff();

	/* ᡼륹סե */
	MBoxFileName = GetMailFile();
}

/******** GetMailFile ********
* ᡼롦סե̾
* ե̾Ǽ malloc Ƥ
*/
static char	*GetMailFile()
{
	char	*username;
	char	*fname_return;

    username = (char*)getlogin();
	if( username == NULL )
	{
		struct passwd	*pw = getpwuid( getuid() );

		if( pw == NULL )
		{
	    	fprintf( stderr,"ERROR: unable to find a username for you.\n" );
			return NULL ;
		}
		username = pw->pw_name;
    }

	fname_return = (char*)malloc(
			strlen(MAILBOX_DIRECTORY) + 1 + strlen(username) + 1 );
	if( fname_return == NULL )
		return NULL ;

	sprintf( fname_return, "%s/%s", MAILBOX_DIRECTORY, username );

	return fname_return ;
}

/******** MoveBiff ********/
void	MoveBiff( x, y )
	int	x, y;
{
	y -= BiffHeight; /* ɥβ̤Ȥ */
	XMoveWindow( Disp, BiffWin, x, y );
}

/******** UpBiff ********/
void	UpBiff( x, y )
	int	x, y;
{
	MoveBiff( x, y );

	XMapWindow( Disp, BiffWin );
	isBiffMapped = True;

	XRaiseWindow( Disp, BiffWin ); /* ̤˽Ф */
	
}

/******** DownBiff ********/
void	DownBiff()
{
	XUnmapWindow( Disp, BiffWin );
	isBiffMapped = False;
}

/******** CheckBiff ********/
#define	BIFF_COUNT	30	/* ºݤ˥᡼ܥååֳ */

void	CheckBiff( x, y )
	int	x, y;
{
	long	mailboxsize;
	static long	LastSize = 0;
	
	Bool	sizeChanged;
	Bool	readSinceLastWrite;

	/* 󥿡դˤʤޤǲ⤷ʤ */
	{	static int	BiffCount = BIFF_COUNT;

		if( ++BiffCount <= BIFF_COUNT )
			return;
		BiffCount = 0;
	}
	
	/* ᡼ܥåå */
	mailboxsize = 0;
	sizeChanged = False;
	readSinceLastWrite = False;
	
	{	struct stat	st;
		
		if( stat( MBoxFileName, &st ) == 0 )
		{
			mailboxsize = st.st_size;
			sizeChanged = (Bool)( mailboxsize != LastSize );
    		readSinceLastWrite = (Bool)(st.st_atime > st.st_mtime);
		}
	}
	LastSize = mailboxsize;

	/* ᡼ܥåʤ⤷϶ */
	if( mailboxsize == 0 )
	{
		DownBiff();
    }

	/* ᡼ɤ */
	else if( readSinceLastWrite )
	{
		if( isBiffMapped )
		{
			DownBiff();
		}
	}

	/* ۤʤäƤ */
	else if( sizeChanged )
	{
		if( ! isBiffMapped )
		{
			XBell( Disp, 33/*volume*/ ); /* Beep! */
			UpBiff( x, y );
		}
    } 
}

/******** CreateBiffPixmap ********/
Pixmap	CreateBiffPixmap( w_ret, h_ret )
	int	*w_ret;
	int	*h_ret;
{
	Pixmap	bitmap;
	Pixmap	mailmap;
	int		width, height;
#define	MARGIN	8
	GC	gc_temp;

	/* ޤȹ⤵ */
	if( isKanji )
	{	XChar2b	kstr[ 128 ];
		Str2bCpy( kstr, BiffMsg );
		width = XTextWidth16( theFont, 
				kstr, strlen(BiffMsg)/2 );
	}else
	{	width = XTextWidth( theFont, BiffMsg, strlen(BiffMsg) );
	}

	if( flagup_width > width ){ width = flagup_width; }
	height = flagup_height + FontHeight;

	width  += 2 * MARGIN;
	height += 3 * MARGIN;

	/* ӥåȥޥåפκ */
	bitmap = XCreatePixmap( Disp, BiffWin, width, height,
					DefaultDepth(Disp,DefaultScreen(Disp)) );

	gc_temp = XCreateGC( Disp, bitmap, 0, NULL );
	XSetFont( Disp, gc_temp, theFont->fid );
	XSetBackground( Disp, gc_temp, BgPixel );

	/* ޤ̥ꥢ */
	XSetForeground( Disp, gc_temp, BgPixel );
	XFillRectangle( Disp, bitmap, gc_temp, 0, 0, width, height );

	/* ᡼γΥӥåȥޥåפ */
	XSetForeground( Disp, gc_temp, FgPixel );
	mailmap = XCreatePixmapFromBitmapData( Disp, BiffWin,
					flagup_bits, flagup_width, flagup_height,
					FgPixel, BgPixel,
				/*	BlackPixel(Disp,0), WhitePixel(Disp,0), /* DEBUG */
					DefaultDepth(Disp,DefaultScreen(Disp)) );

	/* ӥåȥޥåפ򥳥ԡ */
	XCopyArea( Disp, mailmap, bitmap, gc_temp,
			0, 0, flagup_width, flagup_height,
			(width - flagup_width) / 2, MARGIN );

	/* åɽ */
	if( isKanji )
	{	XChar2b	kstr[ 128 ];
		Str2bCpy( kstr, BiffMsg );
		XDrawString16( Disp, bitmap, gc_temp,
				MARGIN, flagup_height + 3 * MARGIN,
				kstr, strlen(BiffMsg)/2
		);
	}else
	{
		XDrawString( Disp, bitmap, gc_temp,
				MARGIN, flagup_height + 3 * MARGIN,
				BiffMsg, strlen(BiffMsg)
		);
	}

	XFreePixmap( Disp, mailmap );
	XFreeGC( Disp, gc_temp );

	/* ֤ͤ */
	*w_ret = width;
	*h_ret = height;
	return bitmap ;
}

/******** DestroyBiff ********/
void	DestroyBiff()
{
	if( MBoxFileName != NULL ){ free( MBoxFileName ); }
	XDestroyWindow( Disp, BiffWin );
}

/******** End of File ********/
