/*
*	xosmulti.c
*		Yet Another Osuwari Multi for X11
*
*	Compile: cc -O xosmulti.c image.c message.c biff.c -o xosmulti -lX11 -lXext
*	Program: T.Nakanishi (e-mail: nakanita@ka2.so-net.ne.jp)
*	Original: for MS-Windows95 programed by Yoshy.
*
*	History: '98/09/17   Beta Version.
*	         '98/09/22   ܸ Beta Version.
*	         '98/10/01   ե륫顼б Beta Version(1).
*	         '98/10/16   Biffǽɲ Beta Version(2).
*	         '98/11/12   ٥Ԥ٤ڤdelilah󡢼ա(^^)
*/

static char	Usage[] = { 
"\n"
"  <<< Yet Another Osuwari Multi * Version1.00 >>>\n"
"\tUsage: xosmulti [-font <fontname>] [-fg <color>] [-bg <color>] [-x <xpos>] [-y <ypos>]\n"
"\n"
};

#include	<stdio.h>
#include	<stdlib.h>
#include	<sys/time.h>

#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/extensions/shape.h>	/* ץƥ󥷥(X11R4ʹ) */

#include	"mul_norm.c"
#include	"mul_close.c"
#include	"mul_urur.c"
#include	"mul_uru2.c"
#include	"mul_ohno.c"
#include	"mul_psyu.c"

#include    "mul_mask.xbm"

#include	"nadecur.xbm"
#include	"nademask.xbm"
#include	"funicur.xbm"
#include	"funimask.xbm"

/********
| 󥯥롼ɡեˤϰʲΥǡޤޤƤޤ
|
|	unsigned int	osuwari_width;	ޥ
|	unsigned int	osuwari_height;	ޥι⤵
|	unsigned char	Palette[];		ѥåȡʶ̡
|
|	unsigned char   mul_norm[];		Ρޥ
|	unsigned char   mul_close[];	Ĥ
|	unsigned char   mul_urur[];		뤦
|	unsigned char   mul_uru2[];		뤦롢Σ
|	unsigned char   mul_ohno[];		ϣ衤Σ
|	unsigned char   mul_psyu[];		ץ塼
|
|	unsigned char mul_mask_bits[];	ޥΥޥ
|
|	unsigned char nadecur_bits[];	ʤǤʤǥ
|	unsigned char nademask_bits[];	ʤǤʤǥޥ
|	unsigned char funicur_bits[];	դˤդ˥
|	unsigned char funimask_bits[];	դˤդ˥ޥ
|	
********/

/******* External Value ********
* åǡϳե message.c ˤޤȤޤäƤޤ
*/
extern char	**NadeMsg;	/* ʤǤʤǥå */
extern char	**FuniMsg;	/* դˤդ˥å */
extern char	*PsyuMsg;	/* ץ塼å */
extern char	*QuitMsg;	/* λΥå */

/******** External Function ********/

/* in image.c */
extern unsigned int	GetDepth( );
extern XImage	*CreateMyImage( );
extern Cursor	CreateMyCursor( );

/* in message.c */
extern void	SetMsgLang( );	/* ܸ <-> Ѹڤؤ */

/* in biff.c */
extern void	CreateBiff();
extern void	MoveBiff( );
extern void	CheckBiff( );
extern void	DownBiff( );
extern void	DestroyBiff();

/******** Constant ********/

#define	TIMER_WAIT	200000	/* ޡֳ֡ۤ® butŤ */

#define	TALK_COUNT	15		/* դνи */
#define	PSYU_COUNT	60		/* Ƥ */
#define	MAX_FUNIFUNI	30	/* դˤդˤǤϰ */

#define	PRIVATE_CMAP	0	/* 顼ޥåס̾Ǥ褤 */

/* Ū֤(̤ʤȤ) */
#ifndef	EXIT_SUCCESS
#define	EXIT_SUCCESS	0
#endif
#ifndef	EXIT_FAILURE
#define	EXIT_FAILURE	1
#endif

/******** Functions Prototype ********/

unsigned long	MyColor( );
void	TalkShape( );

int	InitTalk( );
int	ClearTalk( );
int	NTalkLine( );
int	AppendTalk( );
int	MaxTalkWidth( );

XChar2b	*Str2bCpy( );

void	GetArgs( );
int		main( );
void	TimeHandler( );
void	EventProc( );
void	Do_Draw( );
void	Do_NadeNade( );
void	Do_FuniFuni( );
void	Do_Quit( );
void	Do_Talk( );

/******** Gloval Values ********/

Display	*Disp;
Window	RootWin;
static Window	MainWin, TalkWin;
static GC	TalkGC;

/* եåѥ */
#define	NORM_PAT	0
#define	CLOSE_PAT	1
#define	URUR_PAT	2
#define	URU2_PAT	3
#define	OHNO_PAT	4
#define	PSYU_PAT	5
#define	MAX_PAT		6

static XImage	*MyImage[ MAX_PAT ];
static Cursor	NadeCur, FuniCur;

/* ư⡼ */
#define	NORM_MODE	0
#define	URUR_MODE	1
#define	OHNO_MODE	2
#define	PSYU_MODE	3
#define	QUIT_MODE	4

static int	theMode = NORM_MODE;

static unsigned int	TalkCount = TALK_COUNT;
static unsigned int	FuniCnt = 0;

Colormap	MyColorMap;
unsigned long	FgPixel, BgPixel;

/* ֡Ф룱ʬΨ(%) */
#define	XPOS_RATIO	10
static int	XPosRatio = XPOS_RATIO;

/* 岼֤Ĵ */
#define	YPOS_ADJUST	28
static int	YPosAdjust = YPOS_ADJUST;

/* Ļ롢ԲĻɽե饰 */
static Bool	isMapped = False;
static Bool	isTalkMapped = False;

static char	FontName[ 128 ] = ""; /* ץΥե̾ */

/* ǥեȥեȤΥꥹ * 夫֤ˤƤϤƤߤ */
static char	*DefFontList[] = {
		/*
		* ǥեȥեȤ򥫥ޥȤˤϡ
		* ˥ե̾ɲä
		*/
	"-jis-fixed-medium-r-normal--16-*-*-*-*-*-*-*",	/* Japanese */
	"-adobe-courier-bold-r-normal-*-18-*-*-*-*-*-*-*", /* English */
	NULL /* END MARK */
};

XFontStruct	*theFont;
int		FontHeight;
Bool	isKanji = False;	/* byteʸե饰 */

static Bool	Done    = False;	/* λե饰 */

/******** MyColor ********
* ̾ԥǡ
*/
unsigned long	MyColor( disp, color_name )
	Display	*disp;
	char	*color_name;
{
	Colormap	cmap;
	XColor	c0, c1;

	cmap = DefaultColormap( disp, DefaultScreen(disp) );
	XAllocNamedColor( disp, cmap, color_name, &c1, &c0 );
	return c1.pixel;
}

/******** TalkShepe ********
* ɥ֤դפηڤФ
*/
void	TalkShape( disp, win, width, height, option_flag )
	Display	*disp;
	Window	win;
	int	width, height;
	Bool	option_flag;
{
	GC		gc_mask;
	Pixmap		bitmap;
	int		edge = width / 6;
	XPoint	p[ 3 ];

	/* ޥѥӥåȥޥåפ */
	bitmap = XCreatePixmap( disp, win, width, height, 1/*depth=1*/ );
	gc_mask = XCreateGC( disp, bitmap, 0, NULL );

	/* ޤ̥ꥢ */
	XSetForeground( disp, gc_mask, BlackPixel(disp,DefaultScreen(disp)) );
	XFillRectangle( disp, bitmap, gc_mask, 0, 0, width, height );

	/* ĹξɤȾ */
	XSetForeground( disp, gc_mask, WhitePixel(disp,DefaultScreen(disp)) );
	XFillRectangle( disp, bitmap, gc_mask, edge, 0, width-2*edge, height );
	XFillArc( disp, bitmap, gc_mask, 0,            0, edge*2, height, 0, 360*64 );
	XFillArc( disp, bitmap, gc_mask, width-edge*2, 0, edge*2, height, 0, 360*64 );

	/* ʻѷդ­ */
	/* option_flag ˤäƻѤդ֤Ѥ */
	if( option_flag )
	{	p[0].x = 0;			p[0].y = height;
		p[1].x = edge;		p[1].y = height * 9 / 10;
		p[2].x = edge;		p[2].y = height / 2;
	} else
	{	p[0].x = 0;			p[0].y = 0;
		p[1].x = edge;		p[1].y = height / 10;
		p[2].x = edge;		p[2].y = height / 2;
	}
	XFillPolygon( disp, bitmap, gc_mask, p, 3, Convex, CoordModeOrigin );

	XResizeWindow( disp, win, width, height );
	XShapeCombineMask( disp, win, ShapeBounding, 0, 0, bitmap, ShapeSet );
	
	XFreeGC( disp, gc_mask );
	XFreePixmap( disp, bitmap );
}

/******** TalkLine ********
* ʣԡ֤աפν
*/

typedef	struct	tagTALK_LINE
{	unsigned short	len;	/* = strlen */
	unsigned short	width;	/* ɥɽȤ */
	char	*str;
} TALK_LINE;

#define	N_TALKLINE		7	/* դκԿ */
static TALK_LINE	TalkLines[ N_TALKLINE  + 1 ];

int	InitTalk( )
{	
	int	i;

	for( i=0; i<N_TALKLINE +1; i++ )
	{	TalkLines[i].str = NULL;
		TalkLines[i].len = 0;
		TalkLines[i].width = 0;
	}
	return 0;
}

int	ClearTalk( )
{
	int	i;

	for( i=0; i<N_TALKLINE; i++ )
	{	if( TalkLines[i].str != NULL )
		{	free( TalkLines[i].str );
			TalkLines[i].str = NULL;
			TalkLines[i].len = 0;
			TalkLines[i].width = 0;
		}
	}
	return 0;
}

int	NTalkLine( )
{	
	int	i;
	for( i=0; TalkLines[i].str != NULL; i++ )
		/* LOOP */ ;
	return i;
}

int	AppendTalk( font, str )
	XFontStruct	*font;	
	char	*str;
{
	int		i, j;
	
	if( (i = NTalkLine()) == N_TALKLINE )
	{	
		free( TalkLines[0].str );
		for( j=0; j<N_TALKLINE-1; j++ )
		{	
			TalkLines[j].str = TalkLines[j+1].str;
			TalkLines[j].len = TalkLines[j+1].len;
			TalkLines[j].width = TalkLines[j+1].width;
		}
		i = N_TALKLINE -1;
	}

	TalkLines[i].str = malloc( strlen( str ) + 1 );
	if( TalkLines[i].str == NULL )
	{	fprintf( stderr, "ERROR: malloc\n" );
		ClearTalk();
		return 0;
	}
	strcpy( TalkLines[i].str, str );
	TalkLines[i].len = strlen( str );
	if( isKanji )
	{	XChar2b	kstr[ 128 ];
		Str2bCpy( kstr, TalkLines[i].str );
		TalkLines[i].width = XTextWidth16( font, 
				kstr, TalkLines[i].len /2 );
	}else
	{	TalkLines[i].width = XTextWidth( font, 
				TalkLines[i].str , TalkLines[i].len );
	}
	return i+1;
}

int	MaxTalkWidth( )
{
	int	i, max_width = 0;

	for( i=0; TalkLines[i].str != NULL; i++ )
	{
		if( TalkLines[i].width > max_width )
			max_width = TalkLines[i].width;
	}
	return max_width;
}

/******** Str2bCpy ********
* ʸcharXChar2b ˥ԡ
*/
XChar2b	*Str2bCpy( dst, src )
	XChar2b	*dst;
	char	*src;
{
	int	i;

	for( i=0; i < strlen( src ) / 2; i++ )
	{
		dst[i].byte1 = src[ i*2     ] & 0x7f;
		dst[i].byte2 = src[ i*2 + 1 ] & 0x7f;
	}
	dst[i].byte1 = 
	dst[i].byte2 = '\0';

	return( dst );
}

/******** GetArgs ********
* ν
*/
void	GetArgs( argc, argv )
	int		argc;
	char	*argv[];
{
	int	i;
	
	for( i=1; i<argc; i++ )
	{
		/**** ե ****/
		if( ! strcmp( argv[i], "-font" ) )
		{	
			++i;
			if( argv[i] == NULL )
			{	fprintf( stderr, "WARNING: missing font name, use default\n" );
				continue;
			}

			{	int	cnt;
				XListFonts( Disp, argv[i], 1, &cnt );
				if( cnt == 0 )
				{	fprintf( stderr, "WARNING: bad font name, use default\n" );
					continue;
				}
			}
			strcpy( FontName, argv[i] );
			printf( "INFO: font = %s\n", FontName );
		}

		/**** ذ ****/
		else if( ! strncmp( argv[i], "-x", 2 ) )
		{
			++i;
			if( argv[i] == NULL )
			{	fprintf( stderr, "WARNING: missing X position, use default\n" );
				continue;
			}

			XPosRatio = atoi( argv[i] );
			if( XPosRatio < 0 || 100 < XPosRatio )
			{	fprintf( stderr, "WARNING: xpos(%) must be in 0-100, use default\n" );
				XPosRatio = XPOS_RATIO;
			}
		}

		/**** ٰ ****/
		else if( ! strncmp( argv[i], "-y", 2 ) )
		{
			++i;
			if( argv[i] == NULL )
			{	fprintf( stderr, "WARNING: missing Y position, use default\n" );
				continue;
			}
			
			YPosAdjust = YPOS_ADJUST + atoi( argv[i] );
		}

		/**** ʿ ****/
		else if( ! strcmp( argv[i], "-fg" ) )
		{	
			++i;
			if( argv[i] == NULL )
			{	fprintf( stderr, "WARNING: missing Foreground, use default\n" );
				continue;
			}
			FgPixel = MyColor( Disp, argv[i] );
		}

		/**** طʿ ****/
		else if( ! strcmp( argv[i], "-bg" ) )
		{
			++i;
			if( argv[i] == NULL )
			{	fprintf( stderr, "WARNING: missing Background, use default\n" );
				continue;
			}
			BgPixel = MyColor( Disp, argv[i] );
		}

		/**** إ ****/
		else if( ! strncmp( argv[i], "-h", 2 ) )
		{	printf( "%s", Usage );
			exit( EXIT_SUCCESS );
		}

		/**** 顼 ****/
		else
		{	fprintf( stderr, "ERROR: unknown option \"%s\"\n", argv[i] );
			exit( EXIT_FAILURE );
		}
	}
}/* END GetArgs */

/******** main ********/
int	main( argc, argv )
	int		argc;
	char	*argv[];
{
	struct timeval	delay;
	struct timeval	tvnow;
	struct timeval	tvold;
	int	tm;

	Disp = XOpenDisplay( NULL );
	RootWin = RootWindow( Disp, DefaultScreen(Disp) );
	FgPixel = BlackPixel( Disp, DefaultScreen(Disp) );
	BgPixel = WhitePixel( Disp, DefaultScreen(Disp) );

	GetArgs( argc, argv );

	/**** Create Main Window ****/
	{	
		XSetWindowAttributes	xswa;

		xswa.override_redirect = True;
		xswa.event_mask = 
				ButtonPressMask | ButtonReleaseMask |
				PointerMotionMask | ExposureMask;

		MainWin = XCreateWindow( Disp, RootWin,
				0/*x*/, 0/*y*/, osuwari_width, osuwari_height, 0,
				CopyFromParent/*depth*/, InputOutput, CopyFromParent/*visual*/,
				CWEventMask | CWOverrideRedirect, &xswa );
	}

	/**** Set Main Window Shape ****/
	{	Pixmap		maskbit;

		maskbit = XCreateBitmapFromData( Disp, RootWin,
					mul_mask_bits, mul_mask_width, mul_mask_height );
		XShapeCombineMask( Disp, MainWin, ShapeBounding, 0, 0, maskbit, ShapeSet );

		XFreePixmap( Disp, maskbit );
	}

#if PRIVATE_CMAP
	MyColorMap = XCreateColormap( Disp, MainWin,
					DefaultVisual(Disp,DefaultScreen(Disp)), AllocNone );
#else
	MyColorMap = DefaultColormap( Disp, DefaultScreen(Disp) );
#endif

	XSetWindowColormap( Disp, MainWin, MyColorMap );

	/**** Create Talk Window ****/
	{
		XSetWindowAttributes	xswa;
		int	talk_width = 120, talk_height = 64;

		TalkWin = XCreateSimpleWindow( Disp, RootWin,
				0, 0, talk_width, talk_height, 1,
				FgPixel, BgPixel );

		xswa.override_redirect = True;
		XChangeWindowAttributes( Disp, TalkWin, CWOverrideRedirect, &xswa );
	}

	/**** Loading font ****/
	{
		XGCValues	gcv;
		memset( &gcv, 0, sizeof(XGCValues) );
	
		if( FontName[0] != '\0' ) /* ץǥե̾ꤷ */
		{	theFont = XLoadQueryFont( Disp, FontName );
		}
		else /* ǥեȥեȤΥ */
		{	int	i;
			for( i=0; DefFontList[i] != NULL; i++ )
			{
				theFont = XLoadQueryFont( Disp, DefFontList[ i ] );
				if( theFont != NULL ) /* եȤĤä */
					break;
			}
		}

		/* եȤĤʤä */
		if( theFont == NULL )
		{	fprintf( stderr, "ERROR: Can't find proper default fonts.\n" );
			fprintf( stderr, "       Please use -font option to use suitable font.\n" );
			exit( EXIT_FAILURE );
		}

		/* 2byteեȤɤå */
		if( theFont->min_byte1 | theFont->max_byte1 != 0 )
		{	
		/*	printf( "INFO: Using Japanese Message.\n" ); /* DEBUG */
			SetMsgLang( isKanji = True );
		}
		else
		{	SetMsgLang( isKanji = False );
		}

		FontHeight = theFont->max_bounds.ascent + theFont->max_bounds.descent;
		gcv.font = theFont->fid;
		gcv.foreground = FgPixel;
		gcv.background = BgPixel;
		TalkGC = XCreateGC( Disp, RootWin,
						GCForeground | GCBackground | GCFont, &gcv );
	}

	/******** ********/
	CreateBiff();

	/******** Loading Image & Cursor ********/
	{	unsigned int	depth = GetXDepth( Disp ); /* ǥץ쥤Υ顼⡼ɤ */

		MyImage[ NORM_PAT ] = CreateMyImage( osuwari_width, osuwari_height, Palette, 16, depth, mul_norm );
		MyImage[ CLOSE_PAT] = CreateMyImage( osuwari_width, osuwari_height, Palette, 16, depth, mul_close );
		MyImage[ URUR_PAT ] = CreateMyImage( osuwari_width, osuwari_height, Palette, 16, depth, mul_urur );
		MyImage[ URU2_PAT ] = CreateMyImage( osuwari_width, osuwari_height, Palette, 16, depth, mul_uru2 );
		MyImage[ OHNO_PAT ] = CreateMyImage( osuwari_width, osuwari_height, Palette, 16, depth, mul_ohno );
		MyImage[ PSYU_PAT ] = CreateMyImage( osuwari_width, osuwari_height, Palette, 16, depth, mul_psyu );
	}

	FuniCur = CreateMyCursor( MainWin, funicur_bits, funimask_bits );
	NadeCur = CreateMyCursor( MainWin, nadecur_bits, nademask_bits );

	/**** Initialize ****/

	InitTalk();

	XStoreName( Disp, MainWin, "Osuwari-Multi" );

	XUnmapWindow( Disp, MainWin );
	isMapped = False;
	XUnmapWindow( Disp, TalkWin );
	isTalkMapped = False;

	XFlush( Disp );

	gettimeofday( &tvold, NULL/*&tzone*/ );
	tm = 0;

	/**** Main Loop ****/
	while( ! Done )
	{
	/*	int	conNum = ConnectionNumber( Disp ); /*ά*/
	/*	FD_ZERO( &writefd ); /*ά*/
	/*	FD_ZERO( &exceptfd ); /*ά*/
	/*	FD_ZERO( &readfd ); /*ά*/
	/*	FD_SET( conNum, &readfd ); /*ά*/

		delay.tv_usec = TIMER_WAIT;
		delay.tv_sec  = 0;
		select( 1, NULL, NULL, NULL, &delay );
	/*	select( conNum + 1, &readfd, &writefd, &exceptfd, &delay ); /*ά*/
						/* ֤ޤԤ */

		while( XEventsQueued( Disp, QueuedAfterFlush ) != 0 )
		{	EventProc( ); /* ٥Ƚ */
		}

		gettimeofday( &tvnow, NULL/*&tzone*/ );
		tm += (tvnow.tv_sec  - tvold.tv_sec) * 1000000;
		tm += (tvnow.tv_usec - tvold.tv_usec);
		if ( tm > TIMER_WAIT )
		{
			TimeHandler(); /* ޡϥɥ顼 */
			tm -= TIMER_WAIT;
			tvold.tv_sec  = tvnow.tv_sec;
			tvold.tv_usec = tvnow.tv_usec;
		}
	}

	/**** Exit ****/
	DestroyBiff();

	XDestroyWindow( Disp, TalkWin );
	XDestroyWindow( Disp, MainWin );
#if PRIVATE_CMAP
	XFreeColormap( Disp, MyColorMap );
#endif
	XFreeGC( Disp, TalkGC );
	XFreeFont( Disp, theFont );

	ClearTalk( );

	exit( EXIT_SUCCESS );

}/* END main */

/******** TimeHandler ********
* ֳִ֤ǸƤӽФ
*/
void	TimeHandler( )
{
	Window	focus_win;
	static Window	prev_focus = 0;
	static int	prev_x = 0, prev_y = 0, prev_w = 0;
	int		x, y, w, h, border;

	Window		child;
	int		revert;
	int		depth;

	static int	Biff_x = 0, Biff_y = 0;

	XRaiseWindow( Disp, MainWin ); /* ˺̤˽Ф */
	
	/******** եɥΥå ********/
	
	XGetInputFocus( Disp, &focus_win, &revert );

	if( focus_win != MainWin && focus_win != PointerRoot &&
					focus_win != TalkWin && focus_win != None )
	{
		XSync( Disp, 1 );

		if( ! XGetGeometry( Disp, focus_win, &RootWin, &x, &y, &w, &h, &border, &depth ) )
		{	fprintf( stderr, "ERROR: failed XGetGeometry\n" );
			return;
		}
		
		/* ̤礭ʥɥФƤϽԤʤ() */
		if( w > DisplayWidth(Disp,DefaultScreen(Disp)) ||
			h > DisplayHeight(Disp,DefaultScreen(Disp)) )
			return;

		XTranslateCoordinates( Disp, focus_win, RootWin, 0, 0, &x, &y, &child );

		/* ̤Ϥ߽ФȤˤϽԤʤ() */
		if( x > DisplayWidth(Disp,DefaultScreen(Disp)) ||
			y > DisplayHeight(Disp,DefaultScreen(Disp)) )
			return;

		if( 
			focus_win != prev_focus ||	/* եɥѤä */
			x != prev_x ||	/* ɥΰ֤Ѥä */
			y != prev_y ||
			w != prev_w		/* ɥηѤä */	
		)
		{	int	x_pos = x + (w - osuwari_width) * XPosRatio /100;
			int	y_pos = y - border + 30; /* 30 = ­Ĺ */

			/* äƤ륦ɥ롼ȤľܤλҶɤĴ٤ */
			/* ɥޥ͡㡼ΥȥС̵ͭб */
			{	Window	root_return;
				Window	parent_return;
				Window	*children_return;
				unsigned int	n_children;

				if( ! XQueryTree( Disp, focus_win, &root_return, &parent_return,
						 &children_return, &n_children ) )
				{	fprintf( stderr, "ERROR: on XQueryTree\n" );
				}
				XFree( children_return ); /* ҶϤκݴطʤ */
				
				/* ľܤλҶǤʤСɥޥ͡㡼Ϳ */
				if( parent_return != RootWin )
				{
					y_pos -= YPosAdjust; /* 岼֤Ĵ */
				}
			}
	
			/* ֤ΰư */
			XMoveWindow( Disp, MainWin,
					x_pos,
					y_pos - osuwari_height );

			/* ֤դפΰ֤ΰư */
			XMoveWindow( Disp, TalkWin,
					x_pos + osuwari_width,
					y_pos - osuwari_height /2 );
			
			/* Biff ΰư */
			Biff_x = x_pos + osuwari_width;
			Biff_y = y_pos - osuwari_height / 2;
			MoveBiff( Biff_x, Biff_y );

			if( ! isMapped )
			{	XMapWindow( Disp, MainWin );
				isMapped = True;
			}

			Do_Draw( True ); /* ̺ */

			prev_focus = focus_win;
			prev_x = x;
			prev_y = y;
			prev_w = w;
		}
	}

	/******** Ūʺ ********/
	Do_Draw( False );

	/******** BiffΥå ********/
	if( isMapped )
	{	CheckBiff( Biff_x, Biff_y );
	}

	/******** ֤դפνи ********/
	if( isTalkMapped )
	{
		if( --TalkCount <= 0 )
		{
			XUnmapWindow( Disp, TalkWin ); /* դä */
			isTalkMapped = False;
			ClearTalk( );

			if( theMode != PSYU_MODE )
			{
				theMode = NORM_MODE; /* Ρޥ⡼ɤ */
				Do_Draw( True );
			}
		}
	}

	/******** ֥ץ塼פβ ********/
	if( theMode == PSYU_MODE )
	{	
		static unsigned int	PsyuCount = PSYU_COUNT;
		if( --PsyuCount == 0 )
		{
			theMode = NORM_MODE; /* Ρޥ⡼ɤ */
			Do_Draw( True );
			PsyuCount = PSYU_COUNT;
		}
	}

}/* END TimeHandler */

/******** EventProc ********
* ٥Ƚ
*/
void	EventProc( )
{
	/* 롦⡼ */
#define	NORM_CURMODE	0	/* ̾ */
#define	NADE_CURMODE	1	/* ʤǤʤ */
#define	FUNI_CURMODE	2	/* դˤդ */
	static int	CurMode = NORM_CURMODE;

	static Bool	ButtonPushed = False; /* ߥܥ󤬲Ƥե饰 */
	XEvent	ev;

	XNextEvent( Disp, &ev );
	switch( ev.type )
	{
	case Expose:
		Do_Draw( True );
		break;

	case ButtonPress:
		ButtonPushed = True;

		if( CurMode == FUNI_CURMODE )
		{	
			XDefineCursor( Disp, MainWin, FuniCur );

			/* ֤դˤդˡץ⡼ɤ */
			if( theMode != PSYU_MODE ) /* ץ塼ȲǤʤ */
			{
				if( theMode != OHNO_MODE )
				{	
					if( theMode == QUIT_MODE )
					{	ClearTalk();
					} else
					{	FuniCnt = 0;
					}

					theMode = OHNO_MODE;
					Do_Draw( True );
					
				}
				Do_FuniFuni();
			}
		}
		break;

	case ButtonRelease:
		ButtonPushed = False;

		if( CurMode == FUNI_CURMODE )
		{	XDefineCursor( Disp, MainWin, NadeCur );
		}

		/* λ */
		/* ܥ󣳤 QUIT_MODE -> θܥ󣱤ǽλ */
		switch( ev.xbutton.button )
		{
		case Button1:
			if( theMode == QUIT_MODE )
			{	Done = True; /* ץཪλ */
			}
			break;

		case Button2:
			break;

		case Button3:
			if( theMode == PSYU_MODE ) /* ץ塼ȲǤʤ */
				break;

			if( theMode != QUIT_MODE )
			{	theMode = QUIT_MODE;
				Do_Quit( );
			}	
			else
			/* ܥ󣳤Ϣ³ -> λ󥻥 */
			{	theMode = NORM_MODE;
				TalkCount = 1; /* դä */
			}
			break;
		}
		break;

	case MotionNotify:
		/* ݥ󥿡֤ˤäƥѹ */
		if( ev.xbutton.y > 0 && ev.xbutton.y < 28 &&
			ev.xbutton.x > 0 && ev.xbutton.x < 64 )
		/*֤ʤǤʤǡפǤϰ */
		{
			XDefineCursor( Disp, MainWin, NadeCur );
			CurMode = NADE_CURMODE;
		}
		else if( 50 < ev.xbutton.y && ev.xbutton.y < 64 )
		/*֤դˤդˡפǤϰ */
		{
			if( ButtonPushed )
			{	XDefineCursor( Disp, MainWin, FuniCur );
			}
			else
			{	XDefineCursor( Disp, MainWin, NadeCur );
			}
			CurMode = FUNI_CURMODE;
		}
		else
		{
			XDefineCursor( Disp, MainWin, 0/*Default*/ );
			CurMode = NORM_CURMODE;
		}

		if( theMode == PSYU_MODE ) /* ץ塼ȲǤʤ */
			break;

		/* ֤ʤǤʤǡץ⡼ɤ */
		if( CurMode == NADE_CURMODE && ButtonPushed )
		{
			if( theMode != URUR_MODE )
			{
				if( theMode == QUIT_MODE )
					ClearTalk();

				theMode = URUR_MODE;
				Do_Draw( True );
			}
			Do_NadeNade();
			
			DownBiff();
		}
		break;

	default:
		break;
	}
}/* END EventProc */

/******** Do_Draw ********
* Τ
* ܥѥΥȤʤɤԤäƤ
*  True = ̶
*      False = ɬײսΤ
*/
void	Do_Draw( forced )
	Bool	forced;
{
	static int	Pat = NORM_PAT;
	static unsigned int MepachiCount;
	unsigned int    pachi1, pachi2;
	Bool    drawface = False;

	switch( theMode )
	{
	case NORM_MODE:
	case QUIT_MODE:
		pachi1 = MepachiCount % 15;
		pachi2 = MepachiCount % 18;

		if( pachi1 == 0 || pachi2 == 0 )
		{	Pat = CLOSE_PAT;
			drawface = True;
		}
		else if( pachi1 == 1 || pachi2 == 1 )
		{	Pat = NORM_PAT;
			drawface = True;
		}
		else if( forced )
		{   Pat = NORM_PAT;
		}
		MepachiCount++;
		break;

	case URUR_MODE:
		if( Pat == URUR_PAT )
		{	Pat = URU2_PAT;
		}else
		{	Pat = URUR_PAT;
		}
		drawface = True;
		break;

	case OHNO_MODE:
		pachi1 = MepachiCount % 15;
		pachi2 = MepachiCount % 18;

		if( pachi1 == 0 || pachi2 == 0 )
		{   Pat = PSYU_PAT;
			drawface = True;
		}
		else if( pachi1 == 1 || pachi2 == 1 )
		{   Pat = OHNO_PAT;
			drawface = True;
		}
		else if( forced )
		{   Pat = OHNO_PAT;
		}
		MepachiCount++;
		break;

	case PSYU_MODE:
		Pat = PSYU_PAT;
		break;

	default:
		break;
	}
	
	if( forced ) /* ̺ */
	{
		XPutImage( Disp, MainWin, DefaultGC(Disp,DefaultScreen(Disp)),
			MyImage[ Pat ],
			0, 0, 0, 0, osuwari_width, osuwari_height );
	}
	else if( drawface ) /* ϰϤ褹 */
	{
		XPutImage( Disp, MainWin, DefaultGC(Disp,DefaultScreen(Disp)),
				MyImage[ Pat ],
				12, 25, 12, 25, 40, 30 );

			/* src_x, src_y, dest_x, dest_y, width, height )
			* Face Range : (12,25) - (52,55)
			*/
	}
}

/******** Do_NadeNade ********
* ʤǤʤǥå
*/
void	Do_NadeNade( )
{	
	static unsigned int	nade_cnt;
	char	*str;

	if( ++nade_cnt & 0x0F )
		return;

	if( ! (nade_cnt % (5 * 0x10) ) )
	{	
		str = NadeMsg[0]; /* å */
	}
	else if( ! (nade_cnt % (12 * 0x10) ) )
	{	
		str = NadeMsg[1]; /* å */
	}
	else
	{
		str = NadeMsg[ 2  + ( (nade_cnt>>4) % 4) ];
			/* åְʹߤΣĤ֤˽Ф */
	}

	Do_Talk( str );
}

/******** Do_FuniFuni ********
* դˤդ˥å
*/
void	Do_FuniFuni( )
{	
	char	*str;

	/* ֤դˤդˡפ᤮ȥץ塼 */
	if( ++FuniCnt > MAX_FUNIFUNI )
	{
		str = PsyuMsg; /* ץ塼å */
		theMode = PSYU_MODE;
		Do_Draw( True );

		FuniCnt = 0;
	}

	else if( ! (FuniCnt % 10) )
	{	
		str = FuniMsg[0]; /* å */
	}
	else if( ! (FuniCnt % 14) )
	{	
		str = FuniMsg[1]; /* å */
	}
	else
	{
		str = FuniMsg[ 2  + (FuniCnt % 4) ];
			/* åְʹߤΣĤ֤˽Ф */
	}

	Do_Talk( str );
}

/******** Do_Quit ********
* λå
*/
void	Do_Quit( )
{	
	ClearTalk();

	Do_Talk( QuitMsg );
}

/******** Do_Talk ********
* ֤դפ˥åФ
*/
void	Do_Talk( str )
	char	*str;
{
	int	talk_width, talk_height;
	int	n_line; /* Կ */
	int	i;

	n_line = AppendTalk( theFont, str );
	talk_height = n_line * FontHeight;
	talk_width = MaxTalkWidth( theFont );
	talk_width = talk_width * 9 >> 3; /*  9/8 ܤ */

	TalkShape( Disp, TalkWin, talk_width, talk_height, 0 );

	if( ! isTalkMapped ) /* դФƤʤ */
	{	XMapWindow( Disp, TalkWin ); /* ̾˽Ф */
		isTalkMapped = True;
	}
	TalkCount = TALK_COUNT;
	XRaiseWindow( Disp, TalkWin );

	XSetForeground( Disp, TalkGC, BgPixel ); /* طʤ̤Ĥ֤õ */
	XFillRectangle( Disp, TalkWin, TalkGC, 0, 0, talk_width, talk_height );

	XSetForeground( Disp, TalkGC, FgPixel );
	for( i=0; i < n_line; i++ )
	{
		if( isKanji )
		{	XChar2b	kstr[ 128 ];
			Str2bCpy( kstr, TalkLines[i].str );
			XDrawString16( Disp, TalkWin, TalkGC,
					talk_width / 10,
					FontHeight * i + (FontHeight <<2) /5,
					kstr, TalkLines[i].len /2
			);
		}else
		{
			XDrawString( Disp, TalkWin, TalkGC,
					talk_width / 10,
					FontHeight * i + (FontHeight <<2) /5,
					TalkLines[i].str, TalkLines[i].len
			);
		}
	}
}

/******** End of File ********/

